﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.IntegerVectorEncoding;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;


namespace HeuristicLab.Problems.Scheduling.MRCPSP {
  [Item("Work Content Improver", "")]
  [StorableClass]
  public sealed class WorkContentImprover : BasicMrcpspImprover {

    [StorableConstructor]
    private WorkContentImprover(bool deserializing) : base(deserializing) { }

    private WorkContentImprover(WorkContentImprover original, Cloner cloner) : base(original, cloner) {
      Problem = cloner.Clone(original.Problem);
    }

    public WorkContentImprover() {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new WorkContentImprover(this, cloner);
    }

    protected override int Measure(RealVector randomKey, IntegerVector modeList) => Problem.CalculateWC(randomKey, modeList);
  }
}
